************************************************************************
* File (cc-qcd_ha_14_23__13_16_15.f) created on Sun Nov 30 16:24:43 MSK 2008.
************************************************************************
* This is the FORTRAN module (cc_qcd_ha_14_23__13_16_15) to calculate
* differential cross-section of the gluon induced
* anti-dn + g -> anti-up + mo + mn process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_ha_14_23__13_16_15 (s,spr,ph3,costh3,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,cosph3,sinph3,costh3,sinth3,costh5,sinth5
      real*8 sqrtlsupspr,isqrtlsupspr
      real*8 kappaw
      complex*16 chiwspr,chiwsprc
      real*8 iz1dn,iz2up

      cmw2 = mw2

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      sqrtlsupspr = sqrt(s**2-2d0*s*(rupm2+spr)+(rupm2-spr)**2)
      isqrtlsupspr = 1d0/sqrtlsupspr
      kappaw = gf*rwm2/(sqrt(2d0)*4d0*pi)/alpha
      chiwspr = 4d0*kappaw*spr/(spr-cmw2)
      chiwsprc = dconjg(chiwspr)

      p1p2=
     & +costh5*(-1d0/4*(s-spr))
     & -1d0/4*s+1d0/4*spr

      p1p3=
     & +sinph3*sinth3*sinth5*(-1d0/4*sq*sqspr+1d0/4*sq*sqspr*mmo**2/spr)
     & +costh3*costh5*(1d0/8*mmo**2*s/spr+1d0/8*mmo**2-1d0/8*s-1d0/8*spr
     & )
     & +costh3*(-1d0/8*mmo**2/spr*(s-spr)
     & +1d0/8*(s-spr))
     & +costh5*(-1d0/8*mmo**2/spr*(s-spr)
     & +1d0/8*(s-spr))
     & +1d0/8*mmo**2*s/spr+1d0/8*mmo**2-1d0/8*s-1d0/8*spr

      p1p4=
     & +sinph3*sinth3*sinth5*(1d0/4*sq*sqspr-1d0/4*sq*sqspr*mmo**2/spr)
     & +costh3*costh5*(-1d0/8*mmo**2*s/spr-1d0/8*mmo**2+1d0/8*s+1d0/8*sp
     & r)
     & +costh3*(1d0/8*mmo**2/spr*(s-spr)
     & -1d0/8*(s-spr))+costh5*(1d0/8*mmo**2/spr*(s-spr)
     & +1d0/8*(s-spr))
     & -1d0/8*mmo**2*s/spr-1d0/8*mmo**2-1d0/8*s-1d0/8*spr

      p1p5=
     & -1d0/2*s

      p2p3=
     & +costh3*(-1d0/4*mmo**2/spr*(s-spr)
     & +1d0/4*(s-spr))
     & -1d0/8*mmo**2/s*spr-1d0/8*mmo**2/s*(s-spr)+1d0/8*mmo**2*s/spr+1d0
     & /8*mmo**2/spr*(s-spr)
     & -1d0/8*s+1d0/8*spr-1d0/8*(s-spr)

      p2p4=
     & +costh3*(1d0/4*mmo**2/spr*(s-spr)
     & -1d0/4*(s-spr))+1d0/8*mmo**2/s*spr+1d0/8*mmo**2/s*(s-spr)
     & -1d0/8*mmo**2*s/spr-1d0/8*mmo**2/spr*(s-spr)-1d0/8*s+1d0/8*spr-1d
     & 0/8*(s-spr)

      p2p5=
     & +costh5*(1d0/4*(s-spr))
     & -1d0/4*s+1d0/4*spr

      p3p4=
     & +1d0/2*mmo**2-1d0/2*spr

      p3p5=
     & +sinph3*sinth3*sinth5*(1d0/4*sq*sqspr-1d0/4*sq*sqspr*mmo**2/spr)
     & +costh3*costh5*(-1d0/8*mmo**2*s/spr-1d0/8*mmo**2+1d0/8*s+1d0/8*sp
     & r)
     & +costh3*(-1d0/8*mmo**2/spr*(s-spr)
     & +1d0/8*(s-spr))
     & +costh5*(1d0/8*mmo**2/spr*(s-spr)
     & -1d0/8*(s-spr))+1d0/8*mmo**2*s/spr+1d0/8*mmo**2-1d0/8*s-1d0/8*spr

      p4p5=
     & +sinph3*sinth3*sinth5*(-1d0/4*sq*sqspr+1d0/4*sq*sqspr*mmo**2/spr)
     & +costh3*costh5*(1d0/8*mmo**2*s/spr+1d0/8*mmo**2-1d0/8*s-1d0/8*spr
     & )
     & +costh3*(1d0/8*mmo**2/spr*(s-spr)
     & -1d0/8*(s-spr))+costh5*(-1d0/8*mmo**2/spr*(s-spr)
     & -1d0/8*(s-spr))-1d0/8*mmo**2*s/spr-1d0/8*mmo**2-1d0/8*s-1d0/8*spr

      iz1dn=
     & +1d0/(1-mdn**2/s)*(1d0/s)

      iz2up=
     & +1d0/(1-mdn**2/s)*1d0/(mup**2/s+1d0/4*sqrtlsupspr**2*sinth5**2/s*
     & *2)*(1d0/2*mup**2/s**2-1d0/2/s**2*spr+1d0/2/s+1d0/2*sqrtlsupspr*c
     & osth5/s**2)

      hard=
     & +iz2up**2*chiwspr*chiwsprc/pi*alpha**2*alphas/spr**3*(s-spr)*cf*(
     & 1d0/16*p1p3*p2p4*mup**2*mmo**2/s**2-1d0/16*p1p3*p4p5*mup**2*mmo**
     & 2/s**2)
     & +iz2up**2*chiwspr*chiwsprc/pi*alpha**2*alphas/spr**2*(s-spr)*cf*(
     & -1d0/16*p1p3*p2p4*mup**2/s**2+1d0/16*p1p3*p4p5*mup**2/s**2)
     & +iz2up*chiwspr*chiwsprc/pi*alpha**2*alphas/spr**3*(s-spr)*cf*(1d0
     & /8*p1p2*p1p3*p2p4*mmo**2/s**3-1d0/16*p1p2*p1p3*p4p5*mmo**2/s**3+1
     & d0/16*p1p2*p2p4*p3p5*mmo**2/s**3+1d0/32*p1p3*p2p4*mmo**2/s**2-1d0
     & /32*p1p3*p4p5*mmo**2/s**2+1d0/32*p2p3*p2p4*mmo**2/s**2)
     & +iz2up*chiwspr*chiwsprc/pi*alpha**2*alphas/spr**2*(s-spr)*cf*(-1d
     & 0/8*p1p2*p1p3*p2p4/s**3+1d0/16*p1p2*p1p3*p4p5/s**3-1d0/16*p1p2*p2
     & p4*p3p5/s**3-1d0/32*p1p3*p2p4/s**2+1d0/32*p1p3*p4p5/s**2-1d0/32*p
     & 2p3*p2p4/s**2)
     & +chiwspr*chiwsprc/pi*alpha**2*alphas/spr**3*(s-spr)*cf*(-1d0/32*p
     & 1p3*p1p4*mmo**2/s**3-1d0/32*p1p3*p2p4*mmo**2/s**3-1d0/32*p2p4*p3p
     & 5*mmo**2/s**3)
     & +chiwspr*chiwsprc/pi*alpha**2*alphas/spr**2*(s-spr)*cf*(1d0/32*p1
     & p3*p1p4/s**3+1d0/32*p1p3*p2p4/s**3+1d0/32*p2p4*p3p5/s**3)

      hard = hard*conhc

      return
      end
